#! /bin/sh
# This is a shell archive.  Remove anything before this line, then unpack
# it by saving it into a file and typing "sh file".  To overwrite existing
# files, type "sh file -c".  You can also feed this as standard input via
# unshar, or by typing "sh <file", e.g..  If this archive is complete, you
# will see the following message at the end:
#		"End of archive 1 (of 2)."
# Contents:  ./README.patch1 ./starter/macros ./tools/index.macros
#   ./tools/maketoc ./tools/mktindex ./tools/preproc
#   ./tools/src/indexer.l ./tools/src/psfix.c ./tools/tindex.mac
# Wrapped by hlj@posix on Sun Mar 15 10:19:44 1992
PATH=/bin:/usr/bin:/usr/ucb ; export PATH
if test ! -d "."; then 
  echo shar: creating directory \".\"
    mkdir "."; fi
if test -f ./README.patch1 -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./README.patch1\"
else
echo shar: Extracting \"./README.patch1\" \(679 characters\)
sed "s/^X//" >./README.patch1 <<'END_OF_./README.patch1'
This patch is a 2-file shar archive of replacement files for the PSSG
Draft 5 version of the Starter Kit.  It consists of some bug fixes, but
is primarily a rewrite of the indexing tools to weed out a lot of the
annoying duplicate entries in previous versions.  See the notes at the
beginning of the macros file.

Note that this does not contain a new version of the PSSG and these
changes have not been tested with the old version of the PSSG (although
I doubt there would be a problem).  If you want to continue to produce
PSSG drafts before the next version comes out, I suggest you save the
old versions of these replacement files, just in case.

Hal Jespersen
15 March 1992
END_OF_./README.patch1
if test 679 -ne `wc -c <./README.patch1`; then
    echo shar: \"./README.patch1\" unpacked with wrong size!
fi
# end of overwriting check
fi
if test ! -d "./starter"; then 
  echo shar: creating directory \"./starter\"
    mkdir "./starter"; fi
if test -f ./starter/macros -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./starter/macros\"
else
echo shar: Extracting \"./starter/macros\" \(4143 characters\)
sed "s/^X//" >./starter/macros <<'END_OF_./starter/macros'
X.\" POSIX macros
X.\" Specific section for P1003.1
X.\" This first set of strings and number registers change
X.\" from draft to draft:
X.\" Draft number:
X.ds dR 99
X.\" Draft date:
X.ds dD December 1991
X.nr II .6i	\" Enable Identifier Index
X.\" following 3 no longer used
X.\"ds C1 Strictly Conforming \s-1POSIX.1\s0 Application
X.\"ds C2 Conforming \s-1POSIX.1\s0 Application
X.\"ds C3 Conforming \s-1POSIX.1\s0 Application Using Extensions
X.\" Set up title page.
X.de Tt
Information Technology\*(EM
Portable Operating System Interface (\s-1POSIX\s0)\*(EM
Part 1:
System Application Program Interface
(\s-1API\s0) [C\ Language]\\$1
X..
X.\"
X.\" The following string registers are used:
X.\"
X.\"	t0:	Upper header tag (ISO above IEEE)
X.\"	t1:	Lower header tag
X.\"	t2:	Verso (even-numbered) page header text
X.\"	t3:	Recto (odd-numbered) page header text
X.\"	t6:	Section 1 Main Title
X.\"	t8:	IEEE short name (for title page Draft # label)
X.\"	St:	used for internal references to the standard
X.\"	S1:	Name of the draft or standard without year
X.\"	S2:	Name of the draft or standard with year
X.\"
X.ds t2 \s8INFORMATION TECHNOLOGY\(emPOSIX\s0
X.ds t3 \s8Part 1: SYSTEM API [C LANGUAGE]\s0
X.ds t6 Information technology\*(EMPortable operating system interface (\s-1POSIX\s0)\*(EMPart 1: System application programming interface (\s-1API\s0) [C\ Language]
X.\"
X.\" \nT=0:  IEEE Draft only
X.\"
X.\"
X.if \nT=0 \{\
X.ds t1 \s8P1003.1/D\*(dR\s0
X.ds t8 P1003.1
X.ds nT \&\f2\s-2(This subclause is not a part of P1003.1)\s+2\fP
X.ds St standard
X.ds S1 P1003.1
X.ds S2 P1003.1
X.nr LN 1	\" enable line numbering
X.nr IS 0	\" disable ISOisms
X.nr IE 0	\" disable IEEE standardisms
X.nr Ib 1	\" enable IEEE "boilerplate" and WG/BG lists
X.\}
X.\"
X.\"
X.\" \nT=1:  IEEE Draft, ISO CD combined
X.\"
X.\"
X.if \nT=1 \{\
X.ds t0 \s8ISO/IEC CD 9945-1.1\s0
X.ds t1 \s8P1003.1/D\*(dR\s0
X.ds t8 P1003.1
X.ds nT \&\f2\s-2(This section is not a part of P1003.1)\s+2\fP
X.ds St standard
X.ds S1 P1003.1
X.ds S2 P1003.1
X.nr LN 1	\" enable line numbering
X.nr IS 0	\" disable ISOisms
X.nr IE 0	\" disable IEEE standardisms
X.nr Ib 1	\" enable IEEE "boilerplate" and WG/BG lists
X.\}
X.\"
X.\"
X.\" \nT=2:  IEEE Draft, ISO DIS combined
X.\"
X.\"
X.if \nT=2 \{\
X.ds t0 \s8ISO/IEC DIS 9945-1.2\s0
X.ds t1 \s8P1003.1/D\*(dR\s0
X.ds t8 P1003.1
X.ds St part of \s-1ISO\s0/\s-1IEC\s0\ 9945
X.ds S1 \s-1ISO\s0/\s-1IEC\s0\ 9945-1
X.ds S2 \s-1ISO\s0/\s-1IEC\s0\ 9945-1:\ 1990
X.nr LN 1	\" enable line numbering
X.nr IS 1	\" enable ISOisms
X.nr IE 0	\" disable IEEE standardisms
X.nr Ib 0	\" disable IEEE "boilerplate" and WG/BG lists
X.\}
X.\"
X.\"
X.\" \nT=3:  ISO DIS only
X.\"
X.\"
X.if \nT=3 \{\
X.ds t1 \s8ISO/IEC DIS 9945-1.2\s0
X.ds t8 P1003.1
X.ds St part of \s-1ISO\s0/\s-1IEC\s0\ 9945
X.ds S1 \s-1ISO\s0/\s-1IEC\s0\ 9945-1
X.ds S2 \s-1ISO\s0/\s-1IEC\s0\ 9945-1:\ 1990
X.nr LN 1	\" enable line numbering
X.nr IS 1	\" enable ISOisms
X.nr IE 0	\" disable IEEE standardisms
X.nr Ib 0	\" disable IEEE "boilerplate" and WG/BG lists
X.\}
X.\"
X.\"
X.\" \nT=4:  IEEE Standard only
X.\"
X.\"
X.if \nT=4 \{\
X.ds t1 \s8IEEE Std 1003.1-1990\s0
X.ds t6 IEEE Standard for Information Technology\*(EMPortable Operating System Interface (\s-1POSIX\s0)\*(EMPart 1: System Application Program Interface (\s-1API\s0) [C\ Language]
X.ds t8 P1003.1
X.ds St standard
X.ds S1 \s-1IEEE\s0 Std 1003.1-1990
X.ds S2 \s-1IEEE\s0 Std 1003.1-1990
X.nr LN 1	\" enable line numbering
X.rm dR		\" draft number is null for non-draft
X.nr IS 0	\" disable ISOisms
X.nr IE 1	\" enable IEEE standardisms
X.nr Ib 1	\" enable IEEE "boilerplate" and WG/BG lists
X.\}
X.\"
X.\"
X.\" \nT=5:  IEEE Standard, ISO IS combined
X.\"
X.\"
X.if \nT=5 \{\
X.ds t0 \s8ISO/IEC 9945-1: 1990\s0
X.ds t1 \s8IEEE Std 1003.1-1990\s0
X.ds St part of \s-1ISO\s0/\s-1IEC\s0\ 9945
X.ds S1 \s-1ISO\s0/\s-1IEC\s0\ 9945-1
X.ds S2 \s-1ISO\s0/\s-1IEC\s0\ 9945-1:\ 1990
X.nr LN 1	\" enable line numbering [ISO folks will strip them out]
X.\"rm mc		\" disable diff marks
X.rm dR		\" draft number is null for non-draft
X.nr IS 1	\" enable ISOisms
X.nr IE 1	\" enable IEEE standardisms
X.nr Ib 1	\" enable IEEE "boilerplate" and WG/BG lists [ISO will strip out]
X.\}
X.\" @(#)macros	15.3 11/2/90 11:43:55 Copyright 1989, 1990 IEEE All Rights Reserved
END_OF_./starter/macros
if test 4143 -ne `wc -c <./starter/macros`; then
    echo shar: \"./starter/macros\" unpacked with wrong size!
fi
# end of overwriting check
fi
if test ! -d "./tools"; then 
  echo shar: creating directory \"./tools\"
    mkdir "./tools"; fi
if test -f ./tools/index.macros -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/index.macros\"
else
echo shar: Extracting \"./tools/index.macros\" \(800 characters\)
sed "s/^X//" >./tools/index.macros <<'END_OF_./tools/index.macros'
X.XF index.macros
X.\" These macros assume that the \n(II register is set to a width
X.\" for the lefthand column of the index.
X.BB I
X.nf
X.if \n(II=1 .nr II 1i
X.nr ;; \n(IIu+0.3i
X.nr ;: \n(IIu+0.25i
X.nr :: 5.5i-\n(;;u
X.ta \n(;;u 5.5i 6.5i
X.rm IX	\" remove IX macro from POSIX macros
X.de IX
X.ne 3v
X.nr Xl \\w'\\$5'
X.ds Xk "\ \\h'3n-\\n(Xlu'\\$5
X.di Xi
X.fi
X.na
X.ll \n(::u+0.1i
X.in +\n(;;u
X.ti -\n(;;u
\\$3 {\\$4} \\\\c
X.in -\n(;;u
X.nf
X.di
X.di Xj
X.if '\\$2x'Cmdx'  .ds ,, \s-1\f7\\$1\fP\s+1
X.if '\\$2x'Famx'  .ds ,, \f2\\$1\fP
X.if '\\$2x'Funcx' .ds ,, \f2\\$1\fP\^(\^)
X.if '\\$2x'Hdrx'  .ds ,, \s-1\f7<\\$1>\fP\s+1
X.if '\\$2x'Varx'  .ds ,, \f2\\$1\fP
X.\" If left column entry is too wide, break the line
X.ie \\w'\\*(,,'>\n(;:u \{\
\\*(,,
X.br
\t\\c
X.\}
X.el \\*(,,\t\\c
X.Xi
\\f3\\a\\f1 \\*(Xk
X.br
X.di
X.Xj
X..
END_OF_./tools/index.macros
if test 800 -ne `wc -c <./tools/index.macros`; then
    echo shar: \"./tools/index.macros\" unpacked with wrong size!
fi
chmod +x ./tools/index.macros
# end of overwriting check
fi
if test -f ./tools/maketoc -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/maketoc\"
else
echo shar: Extracting \"./tools/maketoc\" \(2522 characters\)
sed "s/^X//" >./tools/maketoc <<'END_OF_./tools/maketoc'
# Script to make the table of contents for the document.  It cat-s
# together the various pieces and wraps it all in some macros so that
# when .so's into the frontmatter it will print right.  The pieces
# are captured by a special version of the )E macro, which writes
# index entries to a file which the makefile greps out to make a TOC.
# %W% %G% %U% Copyright 1991 IEEE All Rights Reserved

# The resulting file here puts those entries inside the >C macro (where
# mm originally put them) and then does a .TC to dump it.  The rest
# of the stuff is to make .TC do the right things.

# Similarly, Figures and Tables are extracted from and put back into the >L
# macro.   The )F macro puts them there.  The .AU and .RP macros (which POSIX
# doesn't use) also use the same trick of appending to macros.

# Work occurs in the current directory.

# Capture Figures, et. al.  (The digit after "FIG_ENTRY" is a debug tool.)
set -e
echo ".de >L" >total.toc
cat [0-9]*.toc | 
    grep "FIG_ENTRY" | tr '\207' '' |
    sed '
	s/FIG_ENTRY. //
	s/\\f3\\fP/\\-/g
	s/\\f4/\\f2/g
	s/\\f8/\\f7/g
	s/"\\f/"\\\&\\f/
	s/Figure \([A-Z1-9][0-9]*-[1-9]\)  /Figure \1\\0\\0/
	s/Figure \([A-Z1-9][0-9]*-[1-9][0-9]\)  /Figure \1\\0/
	s/Table \([A-Z1-9][0-9]*-[1-9]\)  /Table \1\\0\\0/
	s/Table \([A-Z1-9][0-9]*-[1-9][0-9]\)  /Table \1\\0/
    ' >>total.toc

# Close Figures
echo ".." >>total.toc
#mm's .TC macro needs to know if each class exists.
awk 'BEGIN {Lf=0;Lt=0;Le=0;Lx=0}
/\.if 0=/ {Lf=1;}
/\.if 1=/ {Lt=1;}
/\.if 2=/ {Le=1;}
/\.if 3=/ {Lx=1;}
END { print ".nr !0 " Lf;
      print ".nr !1 " Lt;
      print ".nr !2 " Le;
      print ".nr !3 " Lx; }' total.toc >> total.toc

# Start TOC
echo ".de>C" >>total.toc
# Capture TOC
cat [0-9]*.toc |
    grep "TOC_ENTRY" | 
    sed '
	s/TOC_ENTRY //
	s/\\f4/\\f2/g
	s/\\f8/\\f7/g
	s/"\\f/"\\\&\\f/
    ' >>total.toc

# Close TOC; dump bookeeping stuff and print the TOC.
echo "..
X.\\\" Save stuff to be restored later, including a bunch of macros
X.\\\" that .TC removes.
X.ds xC \*(XC
X.rn )E 1
X.rn )F 2
X.rn DE 3
X.rn DF 4
X.rn DS 5
X.rn FD 6
X.rn FE 7
X.rn FG 8
X.rn FS 9
X.rn H a
X.rn HU b
X.rn TB c
X.rn TP tP
X.\\\" Now set up all the special stuff we need for the TOC
X.ds XC ####
X.de TP	\\\" Top of page for TOC
X.sp |5P
X.tl \\\*(XC
X.sp .5v
X..
X.\\\"             Do it.
X.TC 1 2 4 0
X.\\\" and put things back where we found it.
X.rn tP TP
X.ds XC \*(xC
X.rn 1 )E
X.rn 2 )F
X.rn 3 DE
X.rn 4 DF
X.rn 5 DS
X.rn 6 FD
X.rn 7 FE
X.rn 8 FG
X.rn 9 FS
X.rn a H
X.rn b HU
X.rn c TB
X.mc
" >>total.toc
END_OF_./tools/maketoc
if test 2522 -ne `wc -c <./tools/maketoc`; then
    echo shar: \"./tools/maketoc\" unpacked with wrong size!
fi
chmod +x ./tools/maketoc
# end of overwriting check
fi
if test -f ./tools/mktindex -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/mktindex\"
else
echo shar: Extracting \"./tools/mktindex\" \(4811 characters\)
sed "s/^X//" >./tools/mktindex <<'END_OF_./tools/mktindex'
:
# This script reads the index.raw file and creates the Topical Index

grep '^INDEX#' <index.raw |
# If there's a local fix script in Basedir, filter through that.
if [ -x ../index.fix ]; then
	../index.fix
else
	cat
fi |
# Clean up the file and add headers.  The lines with commas are to
# ensure that every line is interpreted as a comma-separated entity,
# even if the second subfield is only a 0 (to be discarded later).
sed '
	s/INDEX#//
	/^Asynchronous Events/d
	/^Consequences of Errors/d
	/^Description/d
	/^Environment Variables/d
	/^Errors/d
	/^Examples, Usage/d
	/^Exit Status/d
	/^Extended Description/d
	/^External Effects/d
	/^External Influences/d
	/^History of Decisions/d
	/^Input Files/d
	/^Operands/d
	/^Options/d
	/^Output Files/d
	/Rationale/d
	/^References/d
	/^Returns/d
	/^Standard Error/d
	/^Standard Input/d
	/^Standard Output/d
	/^Synopsis/d
	/^Unresolved Objections/d
	/\\f2\\s-2(This subcl/d
	/#\\nP/d
	s/^[Tt]he //
	s/^[Aa] //
	/,/ !{
		s/^\([^ ]*\))/\1),/
		s/^\([^ ]*\)\\f[1P]\([ #]\)/\1\\f1,\2/
	}
	s/\\ / /g
	s/,#/, 0#/
	/,/ !s/#/, 0#/
	s/:,/,/
	s/\\s-1//g
	s/\\s0//g
	s///g
	s///g
	s///g
	s///g
	s/[{}]//g
	s/\\f4/\\f2/g
	s/\\f8/\\f7/g
	1i\
A #HEADER\
B #HEADER\
C #HEADER\
D #HEADER\
E #HEADER\
F #HEADER\
G #HEADER\
H #HEADER\
I #HEADER\
J #HEADER\
K #HEADER\
L #HEADER\
M #HEADER\
N #HEADER\
O #HEADER\
P #HEADER\
Q #HEADER\
R #HEADER\
S #HEADER\
T #HEADER\
U #HEADER\
V #HEADER\
W #HEADER\
XX #HEADER\
Y #HEADER\
Z #HEADER
X' |
sort -u |
# debug tee /tmp/index1.$$ |
tr \# \\12 |
# The previous commands selected lines starting with INDEX, edited
# them a bit, interspersed header lines, deleted the INDEX field, and split
# the two remaining fields into separate lines:
# 	field 1 (index entry)
# 	field 2 (page number)
# In the following sed, the complex logic is thus:
# 1.  h:  copy field 1 to hold space
# 2.  s:  various substitutes on pattern space.  This consists of editing
#	  the copy of field 1 to remove all extraneous characters for
#         the sort to come (this modified field 1 will be the sort key
#	  and the field awk acts upon).  The %[0-9] mods are to get
#	  some of the uniquely formatted sysmbols to sort appropriately.
# 3.  x:  exchange hold/pattern; original field 1 is now in pattern
# 4.  N:  append next line (field 2) to pattern, so it's field1\nfield2
# 5.  H:  append pattern into hold space, so hold is now:
#           modified-field1\nfield1\nfield2
# 6.  x:  exchange hold/pattern
# 7.  s:  substitute pattern space embedded newlines into \t's
#           modified-field1\tfield1\tfield2
# 8.  p:  print it
sed -n '
	h
	s/ *\\(em */0/g
	s/\\\^//g
	s/\\\&//g
	s/\\0//g
	s///g
	s/ //g
	/\\f2/ s/,/%2,/
	/\\f3/ s/,/%3,/
	/\\f7/ s/,/%4,/
	s/\\f[1-9P]//g
	/\[.*\]/ s/,/%6,/
	/<.*>/ s/,/%6,/
	/^_/ s/,/%7,/
	/^..*[._-].*,/ s/,/%9,/
	/,.*[._-]/ s/$/%9/
	/^[A-Z_]/ s/,/%8,/
	/%/ !{
		s/,/%0,/
		s/$/%0/
	}
	s/[<>]//g
	s/[\[\]]//g
	x
	N
	H
	x
	s/\n/	/g
	p
X' |
# debug tee /tmp/index2.$$ |
sort -fd -t'	' +0 -1 +2n |
# debug tee /tmp/index3.$$ |

# Collapse the multiple records for each entry into a single one
# with comma-separated page numbers.  This and the following script
# were inspired by some examples in the book "UNIX Text Processing"
# by Dougherty and O'Reilly.
awk '
BEGIN { ORS = ""; FS = "	" }
{
	if ($1 == current)
		printf (",%s", $3)
	else {
		if (NR == 1)
			printf ("%s", $0)
		else
			printf ("\n%s", $0)
		current = $1
	}
}
X' |

# Split entries into multiple levels, based on a comma.  Collapse
# sequential page number runs into hyphenated ranges.  Weed out unused
# alpha headers [don't print one until a real entry follows it].
# Format lines into troff macros.
awk '
BEGIN { FS = "	" }
{
	if ($3 == "HEADER") {
		lastheader = $1;
		continue;
	}
	if (lastheader != "")
		printf (".I0 %s\n", lastheader);
	lastheader = "";
	n = split ($1, curentry, ",");
	if (n > 2)
		continue;
	m = split ($2, curtext, ",");
	if (curentry[1] == lastentry[1])
		printf (".I2 \"%s\"", curtext[2]);
	else {
		if (n > 1)
			printf (".I1 \"%s\"\n.I2 \"%s\"", \
				curtext[1], curtext[2]);
		else
			printf (".I1 \"%s\"", $2);
		lastentry[1] = curentry[1];
	}
	n = split ($3, pageno, ",");
	last = pageno[1]/1;
	unprinted = 0;
	if (last == 0) {
		printf ("\n");
		continue;
	}
	printf ("\n\\0\\&.\\|.\\|.\\0%s", pageno[1]);
	for (i = 2; i <= n; ++i) {
		this = pageno[i]/1;
		if (this == last + 1) {
			if (unprinted == 0)
				printf ("-");
			unprinted = this;
			last++;
		} else {
			if (unprinted > 0)
				printf ("%d, %s", unprinted, pageno[i]);
			else
				printf (", %s", pageno[i]);
			last = this;
			unprinted = 0;
		}
		if (i == n && unprinted > 0)
			printf ("%d", unprinted);
	}
	printf ("\n");
}
X' |

# A final fixup and then store it away...
sed '
s/=comma=/,/g
s/" /"/
s/I2 "0"/I2/
s/_/_\\%/g
s/%0//g
X' > index.fmt
END_OF_./tools/mktindex
if test 4811 -ne `wc -c <./tools/mktindex`; then
    echo shar: \"./tools/mktindex\" unpacked with wrong size!
fi
chmod +x ./tools/mktindex
# end of overwriting check
fi
if test -f ./tools/preproc -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/preproc\"
else
echo shar: Extracting \"./tools/preproc\" \(3267 characters\)
sed "s/^X//" >./tools/preproc <<'END_OF_./tools/preproc'
:
# This preprocessor is used to get the diff marks (.mc statements) into
# point size 6, as required by the psfix program.
# Depending on the value of the -rT argument given, other required
# preprocessing is done as well.

FMT=T0

set -- `getopt r: $@`
for arg in $*
do
	case $arg in
		-r) FMT=$2; shift 2;;
		--) shift; break;;
	esac
done

case $FMT in
	 T[01]) sed '
		s/^\(.\)mc *\([1-9]\)/\1mc \\f1\\s6\2\\s0\\fP/
		s/^\(.\)[mR]c *|/\1mc \\f1\\s6|\\s0\\fP/
		s/^\(.\)mc *a/\1mc \\f1\\s6A\\s0\\fP/
		s/^\(.\)mc *b/\1mc \\f1\\s6B\\s0\\fP/
		s/^\(.\)mc *c/\1mc \\f1\\s6C\\s0\\fP/
		s/^\(.\)mc *d/\1mc \\f1\\s6D\\s0\\fP/
		s/^\(.\)mc *e/\1mc \\f1\\s6E\\s0\\fP/
		s/^\(.\)mc *f/\1mc \\f1\\s6F\\s0\\fP/
		' $* ;;
	    T2) sed '
		s/^\(.\)mc *\([1-9]\)/\1mc \\f1\\s6\2\\s0\\fP/
		s/^\(.\)[mR]c *|/\1mc \\f1\\s6|\\s0\\fP/
		s/^\(.\)mc *a/\1mc \\f1\\s6A\\s0\\fP/
		s/^\(.\)mc *b/\1mc \\f1\\s6B\\s0\\fP/
		s/^\(.\)mc *c/\1mc \\f1\\s6C\\s0\\fP/
		s/^\(.\)mc *d/\1mc \\f1\\s6D\\s0\\fP/
		s/^\(.\)mc *e/\1mc \\f1\\s6E\\s0\\fP/
		s/^\(.\)mc *f/\1mc \\f1\\s6F\\s0\\fP/
		s/^.r[SE]/.P/
		/^\.ne/d
		' $* ;;
	 T[34]) sed '
		s/^\(.\)mc *[^ ]/\1mc \\f1\\s6|\\s0\\fP/
		s/^.r[SE]/.P/
		/^\.ne/d
		' $* ;;
	    T5) sed '
		s/^\(.\)mc *[^ ]/\1mc \\f1\\s6|\\s0\\fP/
		s/^.r[SE]/.P/
		/^\.ne/d
		' $* ;;
esac |

# uncomment the following line if you are doing bindings to LIS docs:
# tblfix |

# The following sed reduces the point size of capital letter strings.
# Thus, it is no longer necessary to use \s-1ABC\s0 or .SM ABC.
# Thanks to X/Open for a variant of this sed code.
sed '
/SCAPS-OFF/,/SCAPS-ON/ !{
/[A-Z][A-Z&][A-Z&.]*/ s//\\s-1&\\s0/g
/\\s-\\s-11/ s//\\s-1/g
/\\s0\\s+1/ s//\\s+1/g
/\\s0\\s0/ s//\\s0/g
/\\s-1\\s-1/ s//\\s-1/g
/^\\s-1\([.'\''][^a-z ][^a-z ]*\)\\s0/ s//\1/
/\\f\\s-1\(.\)\([^a-z ]*\)\\s0/ s//\\f\1\\s-1\2\\s0/g
/\\f(\\s-1\(..\)\([^a-z ]*\)\\s0/ s//\\f(\1\\s-1\2\\s0/g
/^[.'\''][a-z][a-z]/ s/\\s-1\([^a-z ]*\)\\s0/\1/g
/\\\*\\s-1\(.\)\([^a-z ]*\)\\s0/ s//\\*\1\\s-1\2\\s0/g
/\\\*(\\s-1\(..\)\([A-Z]\)\\s0/ s//\\*(\1\2/g
/\\\*(\\s-1\(..\)\([^a-z ]*\)\\s0/ s//\\*(\1\\s-1\2\\s0/g
/\\n\\s-1\(.\)\([^a-z ]*\)\\s0/ s//\\n\1\\s-1\2\\s0/g
/\\n(\\s-1\(..\)\([^a-z ]*\)\\s0/ s//\\n(\1\\s-1\2\\s0/g
/\\s-1\([^A-Za-z0-9]\)\\s0/ s//\1/g
/\\s-1\\s0/ s///g
/^\\s-1\(\.[A-Z][A-Z]\)\\s0/ s//\1/g
/^\\\\\.\\s-1\([A-Z][A-Z]\)\\s0/ s//\\\\\.\1/g
/^\.\\s/s/^\.\\s-1\([A-Z&]*\)\\s0/.\1/
/^\.SM/ s/\\s-1\([^a-z ]*\)\\s0/\1/g
/^\.\\"/ s/\\s-1\([^a-z ]*\)\\s0/\1/g
/\( *\)\\\([A-Z][A-Z]*\)\\\( *\)/ s//\1\2\3/g
/^\.DS / s/\\s[-+01]*//g
/^\.WC / s/\\s[-+01]*//g
}
/^\.EQ/,/^\.EN/ {
s/\\s-1//g
s/\\s0//g
}
/^\.Ad/ {
s/\\s-1//g
s/\\s0//g
}
/Xt/ {
s/\\s-1//g
s/\\s0//g
}
/[a-zA-Z0-9;|:.,{}()*]/ s/^	/\\0	/
/^\.P[ar] / s/_/_\\%/g
/^\.LM / s/\([A-Z]\)_/\1_\\%/g
/^\.ER / s/_/_\\%/g
/^\.Ty / s/_/_\\%/g
/^\.Ad / s/_/_\\%/g
/^\.L5 / s/_/_\\%/g
/[a-z][A-Z]/ s/\([a-z][a-z]\)\([A-Z][a-z]\)/\1\\%\2/g
X'
# The final substitutes with _'s provide hyphenation points
# for various long names that include underscores.
# The substitute with [a-z][A-Z] is to hyphenate X Window names.
# The line with \\0 adds an unpaddable space to the beginning
# of any line starting with a tab.  This fixes a problem in
# some troffs where tabbed input gets misaligned on the first
# line after a page break.
END_OF_./tools/preproc
if test 3267 -ne `wc -c <./tools/preproc`; then
    echo shar: \"./tools/preproc\" unpacked with wrong size!
fi
chmod +x ./tools/preproc
# end of overwriting check
fi
if test ! -d "./tools/src"; then 
  echo shar: creating directory \"./tools/src\"
    mkdir "./tools/src"; fi
if test -f ./tools/src/indexer.l -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/src/indexer.l\"
else
echo shar: Extracting \"./tools/src/indexer.l\" \(6144 characters\)
sed "s/^X//" >./tools/src/indexer.l <<'END_OF_./tools/src/indexer.l'
%{
/*
	indexer:

	This program uses lex to insert index entries in the output stream.
	There aren't many candidates selected here because the large bulk
	of the useful indexing is done by the object-oriented POSIX macros,
	such as .Fn, .Pr, .LM, etc.

	As of this version, the entries are tailored for the .0 and .1
	LIS standards.  More will be added in future versions.

	Note the the line just preceding "\n" catches almost all words
	in capital letters, except for the ones in the line that precedes IT.

	A big limitation:  This program does not look across line
	boundaries!  The only index entries it will match are those
	on the same line.

	The 4 actions of interest are:

		ECHO	Don't put this string in the index (i.e., don't
			create a .IX on the next line for it)

		save	Put it in the index

		lsave	Put it in the index, but with the first char lowercase

		lallsave
			Put it in the index, but all lowercased

		index("foo"); ECHO
			Put some other string in the index instead.

	October 1991:  Added -c flag to turn off the default indexing
	of words with all capital letters.  This does not include those
	that are specifically selected here, such as POSIX.

	January 1992:  Removed previous 'qq' kludge because of fixes in
	the indexing scripts.  Refined the all caps search algorithm a bit.

						Hal Jespersen
						January 1992

 */
#include <stdio.h>
#include <ctype.h>
#define save { index(yytext); ECHO; }
#define lsave { lower1(yytext); index(temp); ECHO; }
#define lallsave { lowercase(yytext); index(temp); ECHO; }
#define Usage fprintf(stderr, "usage: %s [-c] [file]\n", cmd)
int	caps = 1;	/* set to index capital-letter words */
char	buf[1024];
char	temp[128];
extern int	optind;
extern char	*optarg;
%}
%e 2000
%p 4000
%n 1000
%k 2000
%a 4000
%o 4000
%start R
%%
^\.(Ad|Fn|XR|XE|XF|x|IX|E[Rrv]|L[^I]|\\["])	{ BEGIN 0; ECHO; }
<R>ppropriate..rivil			{ index("appropriate privileges");
					  ECHO; }
<R>4\.1BSD				{ index("BSD, 4.1"); ECHO; }
<R>4\.2BSD				{ index("BSD, 4.2"); ECHO; }
<R>4\.3BSD				{ index("BSD, 4.3"); ECHO; }
<R>4\.4BSD				{ index("BSD, 4.4"); ECHO; }
<R>[Bb]ackground			{ lsave }
<R>[Bb]uilt-*in				{ lsave }
<R>C.[Ss]hell				{ index("C Shell"); ECHO; }
<R>(C\\*.[Ss]tandard|ANSI\ C|\\\*[(]x3)	{ index("C Standard"); ECHO; }
<R>[Cc]onformance			{ lsave }
<R>[Dd]irectory\ .ntr(y|ie)		{ index("directory entry"); ECHO; }
<R>[Dd]irecto				{ index("directory"); ECHO; }
<R>[Dd]ocument				{ lsave }
<R>[Ee]ffective\ [Gg]roup\ ID		{ index("effective group ID"); ECHO; }
<R>[Ee]ffective\ [Uu]ser\ ID		{ index("effective user ID"); ECHO; }
<R>[Ff]ile\ [Dd]escriptor		{ lallsave }
<R>[Ff]ile..ystem			{ index("file system"); ECHO; }
<R>[Ff]oreground			{ lsave }
<R>[Jj]ob.[Cc]ontrol			{ index("job control"); ECHO; }
<R>(Korn..hell|Korn.hell|ksh)		{ index("KornShell"); ECHO; }
<R>[Ll]ocale				{ lsave }
<R>bsolescen				{ index("obsolescent features"); ECHO; }
<R>POSIX\ [Ll]ocale			{ index("POSIX Locale"); ECHO; }
<R>[Pp]athname				{ index("pathname"); ECHO; }
<R>[Pp]ipe				{ lsave }
<R>[Pp]rocess\ [Gg]roup\ ID		{ index("process group ID"); ECHO; }
<R>[Pp]rocess\ [Gg]roup\ ID		{ index("process group ID"); ECHO; }
<R>[Pp]rocess\ ID			{ index("process ID"); ECHO; }
<R>[Rr]eal\ [Gg]roup\ ID		{ index("real group ID"); ECHO; }
<R>[Rr]eal\ [Uu]ser\ ID			{ index("real user ID"); ECHO; }
<R>[Rr]egular\ [Ee]xpression		{ index("regular expression"); ECHO; }
<R>[Ss]ession				{ lsave }
<R>[Ss]hell				{ lsave }
<R>[Ss]upplementary\ [Gg]roup		{ index("supplementary groups"); ECHO; }
<R>System\\*\ III			{ index("System III"); ECHO; }
<R>System\\*\ V				{ index("System V"); ECHO; }
<R>[Tt]erminal				{ lsave }
<R>[Tt]ext\ [Ff]ile			{ lallsave }
<R>[Uu]ndefined				{ lsave }
<R>[Uu]nspecified			{ lsave }
<R>Version\\*\ 7			{ index("Version 7"); ECHO; }
<R>[Ii]mplementation.defined		{ index("implementation defined");
					  ECHO; }
<R>[Ll]anguage.binding.defined		{ index("language-binding defined");
					  ECHO; }
<R>[Ll]anguage..inding			{ index("language binding"); ECHO; }
<R>ISO[/]IEC\\*\ (CD|DP|DIS)*\ *[1-9][-0-9]+	{ save }
<R>ISO[/]CCITT\\*\ X[.][1-9][0-9]+		{ save }
<R>ISO\\*\ (CD|DP|DIS)*\ *[1-9][-0-9]+	{ save }
<R>IEEE\ P*[1-9][.0-9]+[a-d]*		{ save }
<R>P1003\.[0-9]+[a-d]*			{ sprintf(temp, "IEEE %s", yytext);
					  index(temp); ECHO; }
<R>P12[0-9][0-9]\.*[0-9]+[a-d]*		{ sprintf(temp, "IEEE %s", yytext);
					  index(temp); ECHO; }
<R>IEEE\ Std\ [1-9][.0-9]+[a-d]*	{ save }
<R>ANSI\ [A-Z][1-9][.][0-9]+		{ save }
<R>(FIPS|NBSIR)\ [1-9][0-9-]+		{ save }
<R>POSIX[.][1-9][0-9]*			{ save }
<R>\\\*[(]p1				{ index("POSIX.1"); ECHO; }
<R>System\\*\ V				{ save }
<R>X[/]O[Pp][Ee][Nn]			{ save }
<R>X[.]Lib				{ save }
<R>\{[A-Z][A-Z_]+[A-Z0-9]+\}		{ save }
<R>(POSIX|ISO|IEC|ISO[/]IEC|JTC|API|OSE|I[/]O)	{ ECHO; }
<R>\\*[(]EM				{ ECHO; }
<R>[A-Z][-A-Z0-9_&/.]+[a-z]		{ ECHO; }
<R>[a-z][-A-Z0-9_&/.]+			{ ECHO; }
<R>[A-Z_][-A-Z_&/.]+[A-Z0-9_]+		{ if (caps)
						index(yytext); ECHO; }
\n					{
					ECHO;
					BEGIN R;
					if (buf[0]) {
						printf(buf);
						buf[0] = 0;
					}
}
%%
index(str)
char	*str;
{
	char	b[128];

	if (strchr(str, ' '))
		sprintf(b, ".IX \"%s\"\n", str);
	else
		sprintf(b, ".IX %s\n", str);
	strcat(buf, b);
}

/* Put a lowercase version of the string into temp */
lowercase(str)
char	*str;
{
	char	*p, *q;

	for (p = temp, q = str; *p = tolower(*q); p++, q++)
		;
}

/* Put a version of the string into temp with the first char lowercased */
lower1(str)
char	*str;
{
	char	*p, *q;

	for (p = temp, q = str; *p = *q; p++, q++)
		;
	temp[0] = tolower(temp[0]);
}

/* Main routine to handle stdin vs files and process args. */
main(argc, argv)
int	argc;
char	*argv[];
{
	int	i;
	char	*cmd = argv[0];

	while ((i = getopt(argc, argv, "c")) != EOF) {
		switch (i) {
		    default:
			Usage;
			exit(1);
		    case 'c':
			caps = 0;	/* capital words forced off */
			break;
		}
	}
	argc -= optind;
	argv += optind;

	switch (argc) {
	    case 0:
		yyin = stdin;
		break;
	    case 1:
		if (fopen(argv[argc], "r") == NULL) {
			fprintf(stderr, "cannot open %s\n", argv[argc]);
			exit(1);
		}
		break;
	    default:
		Usage;
		exit(1);
		break;
	}
	yylex();
}
END_OF_./tools/src/indexer.l
if test 6144 -ne `wc -c <./tools/src/indexer.l`; then
    echo shar: \"./tools/src/indexer.l\" unpacked with wrong size!
fi
chmod +x ./tools/src/indexer.l
# end of overwriting check
fi
if test -f ./tools/src/psfix.c -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/src/psfix.c\"
else
echo shar: Extracting \"./tools/src/psfix.c\" \(14039 characters\)
sed "s/^X//" >./tools/src/psfix.c <<'END_OF_./tools/src/psfix.c'
/* Documentation for psfix is at the end of this file. */
#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <ctype.h>

extern int	optind;
extern char	*optarg;
#define TROFFUNIT	576	/* troff resolution per inch */
char	buf[1024];		/* main buffer for I/O */
int	font;			/* keep track of current font */
int	pointsize;		/* keep track of current point size */
int	topmargin = 520;	/* highest point on new page for margin shading
				   (expressed in troff units, 576/inch) */
int	botmargin = 5740;	/* lowest point on page for margin shading */
int	linenoxpos = 470;	/* x-coord of line numbers */
int	linenovert = 70;	/* minimum spacing required between line #s */
int	diffxpos = 4200;	/* x-coord of diff marks */
int	shadeleftxpos =	350;	/* x-coord of left shaded margin */
int	shaderightxpos = 4375;	/* x-coord of right shaded margin */

main(argc, argv)
int	argc;
char	*argv[];
{

	int	i, xpos, ypos, height, shading, shade_y;
	int	prevynum, prevymark, lineoff, diffmarking, lastmark;
	int	prevlineno, seqlineno, numbering, resetnums;
	char	marks[256];
	char	tag[2];
	char	figname[256];
	char	*str, *findstring();

	shading = shade_y = lastmark = 0;
	prevynum = prevymark = prevlineno = resetnums = 0;
	numbering = lineoff = 0;
	seqlineno = diffmarking = 1;

	while ((i = getopt(argc, argv, "1b:DmMNs:")) != EOF) {
		switch (i) {
		    default:
			fprintf(stderr,
				"usage: %s [-1DmMN] [-b bottom] [-s seqno]\n", argv[0]);
			exit(1);
		    case 'D':
			diffmarking = 0;	/* diff marks forced off */
			break;
		    case 'm':
			topmargin = 550;	/* use different page
						   dimensions */
			botmargin = 5500;
			linenoxpos = 470;
			diffxpos = 4350;
			shadeleftxpos = 350;
			shaderightxpos = 4550;
			break;
		    case 'M':
			topmargin = 550;	/* use different page
						   dimensions */
			botmargin = 5770;
			linenoxpos = 520;
			diffxpos = 4400;
			shadeleftxpos = 350;
			shaderightxpos = 4550;
			break;
		    case 'b':
			botmargin = atoi(optarg); /* force specific bottom
						     margin */
			break;
		    case 'N':
			lineoff = 1;	/* line numbers forced off */
			break;
		    case '1':
			numbering = 1;	/* page/reset numbers forces line
					   numbering to be on */
			resetnums = 1;
			break;
		    case 's':
			numbering = 1;	/* sequence number forces line
					   numbering to be on */
			seqlineno = atoi(optarg); /* use different
						     starting line number */
			break;
		}
	}
	argc -= optind;
	argv += optind;

	if (!lineoff)
		numbering = 0;	/* in case they were both given */

	while (gets(buf) != NULL) {
		if (*buf == '%') {
			if (strncmp(buf, "%%Page: ", 8) == 0) {
				/* If a new page, reset all our flags */
				prevynum = prevymark = 0;
				if (resetnums)
					seqlineno = 1;
				puts(buf);
				continue;
			}
			if (sscanf(buf, "%%%%HLJ_Lineno@%d@", &i) == 1) {
				/* Found a line number directive. */
				if (!lineoff) {
					seqlineno = i;
					numbering = 1;
					puts(buf);
				}
				continue;
			}
			if (!strcmp(buf, "%%HLJ_Lineno_On")) {
				/* Start/Resume line numbering. */
				if (!lineoff) {
					numbering = 1;
					puts(buf);
				}
				continue;
			}
			if (!strcmp(buf, "%%HLJ_Lineno_Off")) {
				/* Stop line numbering. */
				numbering = 0;
				puts(buf);
				continue;
			}
			if (sscanf(buf, "%%%%HLJ_Rat_Start@%d@", &ypos) == 1) {
				/* Found start of Rationale to be shaded. */
				if (!shading) {
					/* test if we're already shading,
					   which is OK */
					shade_y = ypos;	/* save starting
							   position */
					shading = 1;
				}
				puts(buf);
				continue;
			}
			if (sscanf(buf, "%%%%HLJ_Rat_End@%d@", &ypos) == 1) {
				/* Found end of shaded area. */
				if (shading) {
					/* guard against lone end blocks */
					shade(shade_y, ypos);
				}
				shading = 0;
				shade_y = 0;
				puts(buf);
				continue;
			}
			if (sscanf(buf, "%%%%HLJ_FIG@%[a-zA-Z_0-9/.]@%d@%d@%d@",
				figname, &xpos, &ypos, &height) == 4) {
				/* Found place for embedded PostScript figure.
				   The .fG macros uses "@" to delimit fields
				   because whitespace seems to get translated
				   into funny control characters when troff
				   goes into a diversion, like a .DS.  */
				puts(buf);
				readfig(figname, xpos, ypos, height);
				continue;
			}
		}

		if (sscanf(buf, "%d %[s]", &xpos, tag) == 2) {
			/* Entering a new point size; save it */
			pointsize = xpos;
			puts(buf);
			continue;
		}
		if (sscanf(buf, "%d %[f]", &xpos, tag) == 2) {
			/* Entering a new font position; save it */
			font = xpos;
			puts(buf);
			continue;
		}
		if (sscanf(buf, "%d %[p]", &i, tag) == 2) {
			/* end of page; check shading */
			if (shading) {
				shade(shade_y, botmargin);
					/* shade from previous start
					   to end of page */
				shade_y = topmargin;
					/* set shade-start to top
					   of next page */
			}
			puts(buf);
			continue;
		}


		if (pointsize == 6) {
			/* Process possible diff marks within size 6 */
			marks[0] = marks[1] = marks[2] = 0;
			if (sscanf(buf, "%d(%[1-9ABCDEF|])%[X]",
			    &xpos, marks, tag) == 3
			    && testpos(xpos))
				goto putmark;
			if (sscanf(buf, "%d %d(%[1-9ABCDEF|])%[N]",
			    &xpos, &ypos, marks, tag) == 4
			    && testpos(xpos)
			    && marks[2] == 0) {
				/* for the single mark with N, go to the
				   correct vertical space, because putmark
				   will only use the ()X form */
				printf("%d MY\n", ypos);
				goto putmark;
			}
			if (sscanf(buf, "%d %d(%[1-9ABCDEF|])%[X]",
			    &xpos, &ypos, marks, tag) == 4
			    && testpos(xpos)
			    && marks[2] == 0)
				goto putmark;
			if (sscanf(buf, "%d %d(%[1-9ABCDEF|])%[N]",
			    &xpos, &ypos, marks, tag) == 4
				/* Junk these */
			    && testpos(xpos)
			    && marks[2])
				continue;
			if (sscanf(buf, "(%[1-9ABCDEF|])%[S]", marks, tag) == 2
			    && strchr("1-9ABCDEF|", marks[0]))
				goto putmark;

			/* No match; pass it through and reset flag that
			   would have shown that we put out a diff mark. */
			puts(buf);
			lastmark = 0;
			continue;
putmark:
			/* Common spot to write all the diff marks in the
			   form "4200(m)X" (at a larger point size). */
			if (diffmarking && !lastmark) {
				if (marks[0] == '|')
					/* if a real vertical bar, use a
					   bigger point size so it doesn't
					   look so wimpy */
					printf("12 s\n");
				else
					printf("8 s\n");
				printf("%d(%c)X\n", diffxpos, marks[0]);
				if (marks[0] == '|')
					/* restore tiny point size */
					printf("6 s\n");
				lastmark = 1;
			}
			continue;
		}

		/* Blank out the JunK entries. */
		if ((str = findstring(buf, "JunK")) != NULL)
			memcpy(str, "    ", 4);

		if (numbering && buf[strlen(buf) - 1] == 'N' &&
		    sscanf(buf, "%d %d", &xpos, &ypos) == 2) {
			if (ypos < prevynum ||
			    ypos < topmargin ||
			    ypos > botmargin ||
			    isrule()) {
				puts(buf);
				continue;
			}
			if (font != 1)
				printf("1 f\n");
			printf("8 s\n");
			printf("%d MY\n", ypos);
			printf("%d(%d)X\n", linenoxpos, seqlineno++);
			if (font != 1)
				printf("%d f\n", font);
			printf("%d s\n", pointsize);
			prevynum = ypos + linenovert;
				/* ensure next number is at least
				   linenovert units farther down */
			puts(buf);
			lastmark = 0;
			continue;
		}

		/* No interesting info in this line.  Just write it out. */
		puts(buf);

		/* If we've run into a table with rules, force on lastmark.
		   This will prevent us from thinking we have a clear
		   spot to write in.  Normally, the rules are so thin that
		   two diffmarks overlay each other. */
		if (isrule())
			lastmark = 1;
	}
	if (ferror(stdin)) {
		fprintf(stderr, "Read error on input file\n");
		exit(1);
	}
	exit(0);
}

/* Return success if the horizontal position is in about the right
   range for a diff mark. */
testpos(pos)
int	pos;
{
	if (pos < 2500 || pos > 4500)
		return 0;
	return 1;
}

/* See if string s2 is wholly contained in s1.  Return a pointer to the
   first instance, if so.  If not, return NULL. */
char *
findstring(s1, s2)
char	*s1, *s2;
{
	int	n = strlen(s2);

	while (*s1) {
		if (*s1 != *s2) {
			s1++;
			continue;
		}
		if (strncmp(s1, s2, n) == 0)
			return s1;
		s1++;
	}
	return NULL;
}

/* Return true if we're probably in a table, printing a rule */
isrule()
{
	if (font == 10 &&
	     (findstring(buf, "hhhhh") != NULL ||
	      findstring(buf, "iiiii") != NULL ||
	      findstring(buf, "(c)Y") != NULL ))
		return 1;
	else
		return 0;
}

/*
 * Merge in a PostScript file where its lower left corner is at the
 * position (argx, argy) and it is scaled to fit into height.  All
 * values are in troff units: 576/inch, where the origin is the upper
 * right corner of the page.
 */
readfig(file, argx, argy, height)
char	*file;
int	argx, argy, height;
{
	float	llx, lly, urx, ury;
	int	newllx, newlly, newurx, newury;
	float	scale;
	FILE	*fig;

	if ((fig = fopen(file, "r")) == NULL ){
		fprintf(stderr, "Can't open %s\n", file);
		exit(1);
	}

	printf("/HLJ save def\n"); /* tell PostScript to save the state */
	printf("/showpage {} def\n"); /* suppress any showpages in figure */

	while (fgets(buf, 1024, fig)) {
		buf[strlen(buf) - 1] = 0;	/* remove fgets' trailing \n */
		if (buf[0] != '%')
			puts(buf);
		else if (sscanf(buf, "%%%%BoundingBox:%f %f %f %f",
		    &llx, &lly, &urx, &ury) == 4) {
			newllx = argx;
			newlly = argy;

			/* Figure out the scale desired, based on the height
			   allowed.  A full size picture will have a scale
			   of 8 (there are 8 troff units for each PostScript
			   unit); other scales are directly proportional. */
			scale=((height/8.0)/(ury - lly)) * 8;
			if (scale == 0)
				scale = 8;

			if (newllx == 0) /* If no x coord, center the figure */
				newllx = TROFFUNIT*8.5/2 - scale*(urx - llx)/2;

			/* Tell PostScript how to position and scale
			   the picture */
			printf("%d %d translate\n", newllx, newlly);
			printf("%f %f scale\n", scale, -scale);
			printf("%d %d translate\n", (int)-llx, (int)-lly);
		}
	}
	if (ferror(fig)) {
		fprintf(stderr, "read error on input file %s\n", file);
	}
	printf("HLJ restore\n");	/* restore PostScript state */
	fclose(fig);
}

/* shade() prints shading margin bars for Rationale and other parts of
   text not in the standard.  The args are the Y position for the start
   and end of the marks.
 */
shade(ys, ye)
int ys, ye;
{
	if ((ye - ys) < 75) {
		printf("%%shade(%d, %d) too short\n", ys, ye);
		return;		/* don't shade spuriously short lines */
	}
	printf("/HLJ save def\n");
	printf("%d MX\n", shadeleftxpos);
	printf("%d MY\n", ys);
	printf("200 setlinewidth\n");
	printf(".90 setgray\n");
	printf("0 %d Dl\n", ye - ys);	/* print left bar */
	printf("%d MX\n", shaderightxpos);
	printf("%d MY\n", ys);
	printf("0 %d Dl\n", ye - ys);	/* print right bar */
	printf("HLJ restore\n");
}

/*
psfix:

This program massages the output of psdit (Adobe's TranScript
translator for ditroff-->PostScript) into the desired format for POSIX
documents.

	-- It corrects some troff deficiencies/bugs in handling line
	numbers and diff marks.  (Note:  the problem with diff marks
	occurs only when they are used on the same line as a line
	number; they weave around the right margin without lining up.
	Previous versions of psfix tried to work around this, but there
	were too many problems with the MM macros.  Therefore, this
	version assumes there are no line numbers in the file and it
	puts them in itself.)

	-- It integrates PostScript documents or figures into the
	TranScript file produced by troff.

	-- It supports shaded margins for Rationale.

This program will not work with any other PostScript format, although
it might be easy to modify it to do so.

The troff input has to be prepared in a certain way:

1.  Line numbers have to be turned off in troff.  To turn line numbers
on/off at certain points, embed the following PostScript comments:

	%%HLJ_Lineno@<number>@
	%%HLJ_Lineno_On
	%%HLJ_Lineno_Off

The .Nm macro in the POSIX Editor's Starter Kit handles this insertion.

2.  The diff marks have to be point size 6, although this psfix changes
them internally to be a more readable 8.  (Earlier versions used size 8
directly, but this occasionally caused trouble in notes and footnotes.)
To get the diff marks to be size 6, you can use a sed script:

	sed -e 's/^\(.\)mc *9/\1mc \\f1\\s69\\s0\\fP/' \  
	    -e 's/^\(.\)mc *a/\1mc \\f1\\s6A\\s0\\fP/' 

The preproc script in the Starter Kit does this.

3.  Blank lines in tables that want diff marks (to show deleted lines)
need to be entered as "JunK" on a line by itself.  tbl can't seem to
print the diffmark on the correct line unless you do this.

4.  Figures are called in with the .fG macro, as follows:

	.fG <height> <pathname of figure> [<left-indent>]

The program will scale the figure to fit the space reserved by
<height>.  If the optional <left-indent> is omitted, the fG/psfix
combination centers the figure for an 8.5" page.  Both measurements are
accepted in the typical troff style:  2i, 6n, 3.5c, etc.  Note that the
pathname for the PostScript merge is limited to the characters
"a-zA-Z0-9_/".  And watch out for the preproc script that will add
point-size reductions to various names including runs of capital letters
and underscores.

Examples:

	.fG 4i ps/myfig		[centered]
	.fG 4i ps/myfig 1i	[left side at 1 inch]

5.  Shaded margins can be accomplished with the .rS/.rE (start/stop
Rationale) macro pair.  I selected margin shading, rather than the
entire background, because it is easier to read after copying and
because the full background would have to be done _before_ the text,
which is more difficult.

Update February 1990 to:

	fix up page placements for the new ISO format.
	change line numbers to be generated internally only.
	general logic cleanup in some portions.

Update October 1990 to:

	add -b to specify limit of line numbering and shading.
	add -M to adjust all the page dimensions for a non-POSIX project.
	add -1 to reset line numbers to 1 on each page.

Update January 1992 to:

	remove comments from included PostScript files (particularly EPSF).

				Hal Jespersen
				January 1992

*/
END_OF_./tools/src/psfix.c
if test 14039 -ne `wc -c <./tools/src/psfix.c`; then
    echo shar: \"./tools/src/psfix.c\" unpacked with wrong size!
fi
chmod +x ./tools/src/psfix.c
# end of overwriting check
fi
if test ! -d "./tools"; then 
  echo shar: creating directory \"./tools\"
    mkdir "./tools"; fi
if test -f ./tools/tindex.mac -a "${1}" != "-c" ; then 
  echo shar: Will not over-write existing file \"./tools/tindex.mac\"
else
echo shar: Extracting \"./tools/tindex.mac\" \(335 characters\)
sed "s/^X//" >./tools/tindex.mac <<'END_OF_./tools/tindex.mac'
X.\" Macros for Alphabetic Topical Index
X.ll \nWu
X.de I0
X.sp 2
X.ne 5v
X.na
X.in 0
X.S 14
\\$1
X.S 9
X.sp
X.nr i1 0	\" reset flag
X..
X.de I1
X.nr i1 1	\" set flag to show we were in I1
X.SP 0.2v
X.ne 3v
X.in 3n
X.ti -3n
\&\\$1
X..
X.de I2
X.ie \\n(.$ \{\
X.br
X.in 6n
X.ti -3n
\\$1
X.\}
X.el \{\
X.if !\\n(i1 .br
X.\}
X.nr i1 0	\" reset flag
X..
X.BB T
X.2C
X.S 9
END_OF_./tools/tindex.mac
if test 335 -ne `wc -c <./tools/tindex.mac`; then
    echo shar: \"./tools/tindex.mac\" unpacked with wrong size!
fi
chmod +x ./tools/tindex.mac
# end of overwriting check
fi
echo shar: End of archive 1 \(of 2\).
cp /dev/null ark1isdone
MISSING=""
for I in 1 2 ; do
    if test ! -f ark${I}isdone ; then
	MISSING="${MISSING} ${I}"
    fi
done
if test "${MISSING}" = "" ; then
    echo You have unpacked both archives.
    rm -f ark[1-9]isdone
else
    echo You still need to unpack the following archives:
    echo "        " ${MISSING}
fi
##  End of shell archive.
exit 0
